<Cabbage>
form caption("StepRouter") size(620, 510) guiMode("queue") pluginId("Srtr") colour("black") bundle("./images", "StepRouter.snaps")

; Plugin menu controls
image bounds(25, 25, 140, 33) channel("panelMenu") colour("black")
{
    combobox bounds(0, 0, 55, 16) channel("PluginResizerCombBox") mode("resize") value(3) automatable(0)
    filebutton bounds(60, 0, 16, 16) channel("btnSave") mode("named preset") populate("*.snaps") text("") imgFile("off", "./images/save-white.svg") imgFile("on", "./images/save-white.svg")
    filebutton bounds(81, 0, 16, 16) channel("btnDelete") mode("remove preset") populate("*.snaps") text("") imgFile("off", "./images/delete-white.svg") imgFile("on", "./images/delete-white.svg")
    button bounds(102, 0, 16, 16) channel("btnRandom") text("") presetIgnore(1) imgFile("off", "./images/randomize-white.svg") imgFile("on", "./images/randomize-white.svg")
    button bounds(123, 0, 16, 16) channel("btnClear") text("") presetIgnore(1) imgFile("off", "./images/clear-white.svg") imgFile("on", "./images/clear-white.svg")
    combobox bounds(0, 17, 140, 16) channel("combBoxPresets") populate("*.snaps")
}

; Plugin title
image bounds(190, 27, 240, 30) channel("lblTitle") file("./images/steprouter-title.png")

; Host info
image bounds(430, 25, 120, 33) channel("panelHost") colour("black")
{
    label bounds(0, 0, 120, 16) channel("lblBPM") text("0 BPM")
    label bounds(0, 17, 120, 16) channel("lblTimeSig") text("0/0")
}

; Help link
infobutton bounds(305, 61, 10, 16) channel("btnHelp") file("https://github.com/niflheimmer/steprouter") text("") imgFile("off", "./images/question-white.svg") imgFile("on", "./images/question-white.svg")

; Power
image bounds(550, 13, 37, 52) channel("panelPower") colour("black")
{
    button bounds(3, 0, 30, 32) channel("btnPower") text("") value(1) presetIgnore(1) corners(15) imgFile("off", "./images/power-grey.svg") imgFile("on", "./images/power-white.svg")
    label bounds(0, 37, 37, 16) channel("lblPower") text("PWR") fontColour("white")
}
</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d
</CsOptions>
<CsInstruments>
nchnls_i = 32
nchnls = 32
0dbfs = 1

instr startup
    ; set grid dimensions
    iGridX = 25
    iGridY = 85
    iGridWH = 25
    iGridRad = int(iGridWH / 2 + 1)
    iGridPad = 5

    ; set colors
    SColors[] init 16
    SColors[0] = "brown"
    SColors[1] = "crimson"
    SColors[2] = "salmon"
    SColors[3] = "coral"
    SColors[4] = "gold"
    SColors[5] = "khaki"
    SColors[6] = "greenyellow"
    SColors[7] = "lime"
    SColors[8] = "mediumspringgreen"
    SColors[9] = "mediumaquamarine"
    SColors[10] = "turquoise"
    SColors[11] = "skyblue"
    SColors[12] = "mediumslateblue"
    SColors[13] = "violet"
    SColors[14] = "magenta"
    SColors[15] = "hotpink"

    ; set indexes
    iX init 0
    iY init 0
    
    ; create widgets for each row
    while iY < 16 do
        ; determine one-digit label
        iLbl = iY < 9 ? iY + 1 : iY - 9
        
        ; set parameters for every widget
        SPwrBtn sprintf "bounds(%d, %d, %d, %d) channel(\"btnOn%d\") text(\"%d\") value(0) corners(%d) colour:0(\"grey\") colour:1(\"%s\") outlineColour(\"white\") fontColour:0(\"white\") fontColour:1(\"black\")",
            iGridX, (iGridY + iY * iGridWH), iGridWH, iGridWH, iY, iLbl, iGridRad, SColors[iY]
        SGainKnob sprintf "bounds(%d, %d, %d, %d) channel(\"knobGain%d\") range(0, 2, 1, 1, 0.01) popupPrefix(\"Gain: \") colour(\"black\") markerColour(\"white\") outlineColour(\"grey\") trackerColour(\"%s\")",
            (iGridX + iGridWH + iGridPad), (iGridY + iY * iGridWH), iGridWH, iGridWH, iY, SColors[iY]
        SNumKnob sprintf "bounds(%d, %d, %d, %d) channel(\"knobStepNum%d\") range(1, 16, 16, 1, 1) popupPostfix(\" steps\") colour(\"black\") markerColour(\"white\") outlineColour(\"grey\") trackerColour(\"%s\")",
            (iGridX + iGridWH*18 + iGridPad*3), (iGridY + iY * iGridWH), iGridWH, iGridWH, iY, SColors[iY]
        SLenKnob sprintf "bounds(%d, %d, %d, %d) channel(\"knobStepLen%d\") range(0, 5, 0, 1, 1) value(2) popupText(\"Step Length\") colour(\"black\") markerColour(\"white\") outlineColour(\"grey\") trackerColour(\"%s\")",
            (iGridX + iGridWH*19 + iGridPad*4), (iGridY + iY * iGridWH), iGridWH, iGridWH, iY, SColors[iY]
        SLenLbl sprintf "bounds(%d, %d, 45, 16) channel(\"lblStepLen%d\") visible(0) text(\"init\") align(\"left\") fontStyle(\"plain\") fontColour(\"white\")",
            (iGridX + iGridWH*20 + iGridPad*5), (iGridY + iY * iGridWH + 4), iY
        
        ; create widgets
        cabbageCreate "button", SPwrBtn
        cabbageCreate "rslider", SGainKnob
        cabbageCreate "rslider", SNumKnob
        cabbageCreate "rslider", SLenKnob
        cabbageCreate "label", SLenLbl
        
        ; create sequence buttons
        iX = 0
        while iX < 16 do
            SSeqBtn sprintf "bounds(%d, %d, %d, %d) channel(\"btnSeq%dStep%d\") text(\"\") corners(%d) colour:0(\"grey\") colour:1(\"%s\") outlineColour(\"white\")",
                (iGridX + iGridWH*2 + iGridPad*2 + iX * iGridWH), (iGridY + iY * iGridWH), iGridWH, iGridWH, iY, iX, iGridRad, SColors[iY]
            cabbageCreate "button", SSeqBtn
            iX += 1
        od
        iY += 1
    od
endin

instr main
    ; get host info
    gkIsPlaying cabbageGetValue "IS_PLAYING"
    gkBPM cabbageGetValue "HOST_BPM"
    gkTimeSigNum cabbageGetValue "TIME_SIG_NUM"
    gkTimeSigDenom cabbageGetValue "TIME_SIG_DENOM"

    ; get plugin info
    gkPower cabbageGetValue "btnPower"
    kRandom cabbageGetValue "btnRandom"
    kClear cabbageGetValue "btnClear"

    ; init sequence triggers
    gkTrigger0 init 0
    gkTrigger1 init 0
    gkTrigger2 init 0
    gkTrigger3 init 0
    gkTrigger4 init 0
    gkTrigger5 init 0
    gkTrigger6 init 0
    gkTrigger7 init 0
    gkTrigger8 init 0
    gkTrigger9 init 0
    gkTrigger10 init 0
    gkTrigger11 init 0
    gkTrigger12 init 0
    gkTrigger13 init 0
    gkTrigger14 init 0
    gkTrigger15 init 0
    
    ; init step indexes
    gkStepIndex0 init 0
    gkStepIndex1 init 0
    gkStepIndex2 init 0
    gkStepIndex3 init 0
    gkStepIndex4 init 0
    gkStepIndex5 init 0
    gkStepIndex6 init 0
    gkStepIndex7 init 0
    gkStepIndex8 init 0
    gkStepIndex9 init 0
    gkStepIndex10 init 0
    gkStepIndex11 init 0
    gkStepIndex12 init 0
    gkStepIndex13 init 0
    gkStepIndex14 init 0
    gkStepIndex15 init 0
    
    ; init last step indexes
    gkLastStepIndex0 init -1
    gkLastStepIndex1 init -1
    gkLastStepIndex2 init -1
    gkLastStepIndex3 init -1
    gkLastStepIndex4 init -1
    gkLastStepIndex5 init -1
    gkLastStepIndex6 init -1
    gkLastStepIndex7 init -1
    gkLastStepIndex8 init -1
    gkLastStepIndex9 init -1
    gkLastStepIndex10 init -1
    gkLastStepIndex11 init -1
    gkLastStepIndex12 init -1
    gkLastStepIndex13 init -1
    gkLastStepIndex14 init -1
    gkLastStepIndex15 init -1
    
    ; init sequencer on values
    gkSeqOn0 init 0
    gkSeqOn1 init 0
    gkSeqOn2 init 0
    gkSeqOn3 init 0
    gkSeqOn4 init 0
    gkSeqOn5 init 0
    gkSeqOn6 init 0
    gkSeqOn7 init 0
    gkSeqOn8 init 0
    gkSeqOn9 init 0
    gkSeqOn10 init 0
    gkSeqOn11 init 0
    gkSeqOn12 init 0
    gkSeqOn13 init 0
    gkSeqOn14 init 0
    gkSeqOn15 init 0
    
    ; get on button channels
    gkOn0 cabbageGetValue "btnOn0"
    gkOn1 cabbageGetValue "btnOn1"
    gkOn2 cabbageGetValue "btnOn2"
    gkOn3 cabbageGetValue "btnOn3"
    gkOn4 cabbageGetValue "btnOn4"
    gkOn5 cabbageGetValue "btnOn5"
    gkOn6 cabbageGetValue "btnOn6"
    gkOn7 cabbageGetValue "btnOn7"
    gkOn8 cabbageGetValue "btnOn8"
    gkOn9 cabbageGetValue "btnOn9"
    gkOn10 cabbageGetValue "btnOn10"
    gkOn11 cabbageGetValue "btnOn11"
    gkOn12 cabbageGetValue "btnOn12"
    gkOn13 cabbageGetValue "btnOn13"
    gkOn14 cabbageGetValue "btnOn14"
    gkOn15 cabbageGetValue "btnOn15"
    
    ; get gain knob channels
    gkGain0 cabbageGetValue "knobGain0"
    gkGain1 cabbageGetValue "knobGain1"
    gkGain2 cabbageGetValue "knobGain2"
    gkGain3 cabbageGetValue "knobGain3"
    gkGain4 cabbageGetValue "knobGain4"
    gkGain5 cabbageGetValue "knobGain5"
    gkGain6 cabbageGetValue "knobGain6"
    gkGain7 cabbageGetValue "knobGain7"
    gkGain8 cabbageGetValue "knobGain8"
    gkGain9 cabbageGetValue "knobGain9"
    gkGain10 cabbageGetValue "knobGain10"
    gkGain11 cabbageGetValue "knobGain11"
    gkGain12 cabbageGetValue "knobGain12"
    gkGain13 cabbageGetValue "knobGain13"
    gkGain14 cabbageGetValue "knobGain14"
    gkGain15 cabbageGetValue "knobGain15"
    
    ; get step number knob channels
    gkStepNum0 cabbageGetValue "knobStepNum0"
    gkStepNum1 cabbageGetValue "knobStepNum1"
    gkStepNum2 cabbageGetValue "knobStepNum2"
    gkStepNum3 cabbageGetValue "knobStepNum3"
    gkStepNum4 cabbageGetValue "knobStepNum4"
    gkStepNum5 cabbageGetValue "knobStepNum5"
    gkStepNum6 cabbageGetValue "knobStepNum6"
    gkStepNum7 cabbageGetValue "knobStepNum7"
    gkStepNum8 cabbageGetValue "knobStepNum8"
    gkStepNum9 cabbageGetValue "knobStepNum9"
    gkStepNum10 cabbageGetValue "knobStepNum10"
    gkStepNum11 cabbageGetValue "knobStepNum11"
    gkStepNum12 cabbageGetValue "knobStepNum12"
    gkStepNum13 cabbageGetValue "knobStepNum13"
    gkStepNum14 cabbageGetValue "knobStepNum14"
    gkStepNum15 cabbageGetValue "knobStepNum15"
    
    ; get step length knob channels
    gkStepLen0 cabbageGetValue "knobStepLen0"
    gkStepLen1 cabbageGetValue "knobStepLen1"
    gkStepLen2 cabbageGetValue "knobStepLen2"
    gkStepLen3 cabbageGetValue "knobStepLen3"
    gkStepLen4 cabbageGetValue "knobStepLen4"
    gkStepLen5 cabbageGetValue "knobStepLen5"
    gkStepLen6 cabbageGetValue "knobStepLen6"
    gkStepLen7 cabbageGetValue "knobStepLen7"
    gkStepLen8 cabbageGetValue "knobStepLen8"
    gkStepLen9 cabbageGetValue "knobStepLen9"
    gkStepLen10 cabbageGetValue "knobStepLen10"
    gkStepLen11 cabbageGetValue "knobStepLen11"
    gkStepLen12 cabbageGetValue "knobStepLen12"
    gkStepLen13 cabbageGetValue "knobStepLen13"
    gkStepLen14 cabbageGetValue "knobStepLen14"
    gkStepLen15 cabbageGetValue "knobStepLen15"

    ; set metronome speeds
    gkMetroSpeed0 divz (gkBPM * (2^gkStepLen0)), (60 * gkTimeSigNum), 4
    gkMetroSpeed1 divz (gkBPM * (2^gkStepLen1)), (60 * gkTimeSigNum), 4
    gkMetroSpeed2 divz (gkBPM * (2^gkStepLen2)), (60 * gkTimeSigNum), 4
    gkMetroSpeed3 divz (gkBPM * (2^gkStepLen3)), (60 * gkTimeSigNum), 4
    gkMetroSpeed4 divz (gkBPM * (2^gkStepLen4)), (60 * gkTimeSigNum), 4
    gkMetroSpeed5 divz (gkBPM * (2^gkStepLen5)), (60 * gkTimeSigNum), 4
    gkMetroSpeed6 divz (gkBPM * (2^gkStepLen6)), (60 * gkTimeSigNum), 4
    gkMetroSpeed7 divz (gkBPM * (2^gkStepLen7)), (60 * gkTimeSigNum), 4
    gkMetroSpeed8 divz (gkBPM * (2^gkStepLen8)), (60 * gkTimeSigNum), 4
    gkMetroSpeed9 divz (gkBPM * (2^gkStepLen9)), (60 * gkTimeSigNum), 4
    gkMetroSpeed10 divz (gkBPM * (2^gkStepLen10)), (60 * gkTimeSigNum), 4
    gkMetroSpeed11 divz (gkBPM * (2^gkStepLen11)), (60 * gkTimeSigNum), 4
    gkMetroSpeed12 divz (gkBPM * (2^gkStepLen12)), (60 * gkTimeSigNum), 4
    gkMetroSpeed13 divz (gkBPM * (2^gkStepLen13)), (60 * gkTimeSigNum), 4
    gkMetroSpeed14 divz (gkBPM * (2^gkStepLen14)), (60 * gkTimeSigNum), 4
    gkMetroSpeed15 divz (gkBPM * (2^gkStepLen15)), (60 * gkTimeSigNum), 4

    ; set step length names
    SStepLens[] init 6
    SStepLens[0] = "Whole"
    SStepLens[1] = "Half"
    SStepLens[2] = "Qtr"
    SStepLens[3] = "8th"
    SStepLens[4] = "16th"
    SStepLens[5] = "32nd"

    ; update BPM view
    if changed(gkBPM) == 1 then
        cabbageSet 1, "lblBPM", "text", sprintfk("%d BPM", gkBPM)
    endif

    ; update time signature view
    if changed(gkTimeSigNum) == 1 || changed(gkTimeSigDenom) == 1 then
        cabbageSet 1, "lblTimeSig", "text", sprintfk("%d/%d", gkTimeSigNum, gkTimeSigDenom)
    endif
    
    ; update step length texts
    if changed(gkStepLen0) == 1 then
        cabbageSet 1, "lblStepLen0", "text", SStepLens[gkStepLen0]
    endif
    if changed(gkStepLen1) == 1 then
        cabbageSet 1, "lblStepLen1", "text", SStepLens[gkStepLen1]
    endif
    if changed(gkStepLen2) == 1 then
        cabbageSet 1, "lblStepLen2", "text", SStepLens[gkStepLen2]
    endif
    if changed(gkStepLen3) == 1 then
        cabbageSet 1, "lblStepLen3", "text", SStepLens[gkStepLen3]
    endif
    if changed(gkStepLen4) == 1 then
        cabbageSet 1, "lblStepLen4", "text", SStepLens[gkStepLen4]
    endif
    if changed(gkStepLen5) == 1 then
        cabbageSet 1, "lblStepLen5", "text", SStepLens[gkStepLen5]
    endif
    if changed(gkStepLen6) == 1 then
        cabbageSet 1, "lblStepLen6", "text", SStepLens[gkStepLen6]
    endif
    if changed(gkStepLen7) == 1 then
        cabbageSet 1, "lblStepLen7", "text", SStepLens[gkStepLen7]
    endif
    if changed(gkStepLen8) == 1 then
        cabbageSet 1, "lblStepLen8", "text", SStepLens[gkStepLen8]
    endif
    if changed(gkStepLen9) == 1 then
        cabbageSet 1, "lblStepLen9", "text", SStepLens[gkStepLen9]
    endif
    if changed(gkStepLen10) == 1 then
        cabbageSet 1, "lblStepLen10", "text", SStepLens[gkStepLen10]
    endif
    if changed(gkStepLen11) == 1 then
        cabbageSet 1, "lblStepLen11", "text", SStepLens[gkStepLen11]
    endif
    if changed(gkStepLen12) == 1 then
        cabbageSet 1, "lblStepLen12", "text", SStepLens[gkStepLen12]
    endif
    if changed(gkStepLen13) == 1 then
        cabbageSet 1, "lblStepLen13", "text", SStepLens[gkStepLen13]
    endif
    if changed(gkStepLen14) == 1 then
        cabbageSet 1, "lblStepLen14", "text", SStepLens[gkStepLen14]
    endif
    if changed(gkStepLen15) == 1 then
        cabbageSet 1, "lblStepLen15", "text", SStepLens[gkStepLen15]
    endif
    
    ; update step length visibilities & enable sequencers if during playback
    if changed(gkOn0) == 1 then
        cabbageSet 1, "lblStepLen0", "visible", gkOn0
        if gkIsPlaying == 1 && gkPower == 1 && gkOn0 == 1 && gkSeqOn0 == 0 then
            ; start sequencer
            event "i", "sequencer0", 0, 604800
            ; set sequencer as turned on
            gkSeqOn0 = 1
        else
            ; stop sequencer
            turnoff2 "sequencer0", 0, 0
            ; set sequencer as turned off
            gkSeqOn0 = 0
        endif
    endif
    if changed(gkOn1) == 1 then
        cabbageSet 1, "lblStepLen1", "visible", gkOn1
        if gkIsPlaying == 1 && gkPower == 1 && gkOn1 == 1 && gkSeqOn1 == 0 then
            ; start sequencer
            event "i", "sequencer1", 0, 604800
            ; set sequencer as turned on
            gkSeqOn1 = 1
        else
            ; stop sequencer
            turnoff2 "sequencer1", 0, 0
            ; set sequencer as turned off
            gkSeqOn1 = 0
        endif
    endif
    if changed(gkOn2) == 1 then
        cabbageSet 1, "lblStepLen2", "visible", gkOn2
        if gkIsPlaying == 1 && gkPower == 1 && gkOn2 == 1 && gkSeqOn2 == 0 then
            ; start sequencer
            event "i", "sequencer2", 0, 604800
            ; set sequencer as turned on
            gkSeqOn2 = 1
        else
            ; stop sequencer
            turnoff2 "sequencer2", 0, 0
            ; set sequencer as turned off
            gkSeqOn2 = 0
        endif
    endif
    if changed(gkOn3) == 1 then
        cabbageSet 1, "lblStepLen3", "visible", gkOn3
        if gkIsPlaying == 1 && gkPower == 1 && gkOn3 == 1 && gkSeqOn3 == 0 then
            ; start sequencer
            event "i", "sequencer3", 0, 604800
            ; set sequencer as turned on
            gkSeqOn3 = 1
        else
            ; stop sequencer
            turnoff2 "sequencer3", 0, 0
            ; set sequencer as turned off
            gkSeqOn3 = 0
        endif
    endif
    if changed(gkOn4) == 1 then
        cabbageSet 1, "lblStepLen4", "visible", gkOn4
        if gkIsPlaying == 1 && gkPower == 1 && gkOn4 == 1 && gkSeqOn4 == 0 then
            ; start sequencer
            event "i", "sequencer4", 0, 604800
            ; set sequencer as turned on
            gkSeqOn4 = 1
        else
            ; stop sequencer
            turnoff2 "sequencer4", 0, 0
            ; set sequencer as turned off
            gkSeqOn4 = 0
        endif
    endif
    if changed(gkOn5) == 1 then
        cabbageSet 1, "lblStepLen5", "visible", gkOn5
        if gkIsPlaying == 1 && gkPower == 1 && gkOn5 == 1 && gkSeqOn5 == 0 then
            ; start sequencer
            event "i", "sequencer5", 0, 604800
            ; set sequencer as turned on
            gkSeqOn5 = 1
        else
            ; stop sequencer
            turnoff2 "sequencer5", 0, 0
            ; set sequencer as turned off
            gkSeqOn5 = 0
        endif
    endif
    if changed(gkOn6) == 1 then
        cabbageSet 1, "lblStepLen6", "visible", gkOn6
        if gkIsPlaying == 1 && gkPower == 1 && gkOn6 == 1 && gkSeqOn6 == 0 then
            ; start sequencer
            event "i", "sequencer6", 0, 604800
            ; set sequencer as turned on
            gkSeqOn6 = 1
        else
            ; stop sequencer
            turnoff2 "sequencer6", 0, 0
            ; set sequencer as turned off
            gkSeqOn6 = 0
        endif
    endif
    if changed(gkOn7) == 1 then
        cabbageSet 1, "lblStepLen7", "visible", gkOn7
        if gkIsPlaying == 1 && gkPower == 1 && gkOn7 == 1 && gkSeqOn7 == 0 then
            ; start sequencer
            event "i", "sequencer7", 0, 604800
            ; set sequencer as turned on
            gkSeqOn7 = 1
        else
            ; stop sequencer
            turnoff2 "sequencer7", 0, 0
            ; set sequencer as turned off
            gkSeqOn7 = 0
        endif
    endif
    if changed(gkOn8) == 1 then
        cabbageSet 1, "lblStepLen8", "visible", gkOn8
        if gkIsPlaying == 1 && gkPower == 1 && gkOn8 == 1 && gkSeqOn8 == 0 then
            ; start sequencer
            event "i", "sequencer8", 0, 604800
            ; set sequencer as turned on
            gkSeqOn8 = 1
        else
            ; stop sequencer
            turnoff2 "sequencer8", 0, 0
            ; set sequencer as turned off
            gkSeqOn8 = 0
        endif
    endif
    if changed(gkOn9) == 1 then
        cabbageSet 1, "lblStepLen9", "visible", gkOn9
        if gkIsPlaying == 1 && gkPower == 1 && gkOn9 == 1 && gkSeqOn9 == 0 then
            ; start sequencer
            event "i", "sequencer9", 0, 604800
            ; set sequencer as turned on
            gkSeqOn9 = 1
        else
            ; stop sequencer
            turnoff2 "sequencer9", 0, 0
            ; set sequencer as turned off
            gkSeqOn9 = 0
        endif
    endif
    if changed(gkOn10) == 1 then
        cabbageSet 1, "lblStepLen10", "visible", gkOn10
        if gkIsPlaying == 1 && gkPower == 1 && gkOn10 == 1 && gkSeqOn10 == 0 then
            ; start sequencer
            event "i", "sequencer10", 0, 604800
            ; set sequencer as turned on
            gkSeqOn10 = 1
        else
            ; stop sequencer
            turnoff2 "sequencer10", 0, 0
            ; set sequencer as turned off
            gkSeqOn10 = 0
        endif
    endif
    if changed(gkOn11) == 1 then
        cabbageSet 1, "lblStepLen11", "visible", gkOn11
        if gkIsPlaying == 1 && gkPower == 1 && gkOn11 == 1 && gkSeqOn11 == 0 then
            ; start sequencer
            event "i", "sequencer11", 0, 604800
            ; set sequencer as turned on
            gkSeqOn11 = 1
        else
            ; stop sequencer
            turnoff2 "sequencer11", 0, 0
            ; set sequencer as turned off
            gkSeqOn11 = 0
        endif
    endif
    if changed(gkOn12) == 1 then
        cabbageSet 1, "lblStepLen12", "visible", gkOn12
        if gkIsPlaying == 1 && gkPower == 1 && gkOn12 == 1 && gkSeqOn12 == 0 then
            ; start sequencer
            event "i", "sequencer12", 0, 604800
            ; set sequencer as turned on
            gkSeqOn12 = 1
        else
            ; stop sequencer
            turnoff2 "sequencer12", 0, 0
            ; set sequencer as turned off
            gkSeqOn12 = 0
        endif
    endif
    if changed(gkOn13) == 1 then
        cabbageSet 1, "lblStepLen13", "visible", gkOn13
        if gkIsPlaying == 1 && gkPower == 1 && gkOn13 == 1 && gkSeqOn13 == 0 then
            ; start sequencer
            event "i", "sequencer13", 0, 604800
            ; set sequencer as turned on
            gkSeqOn13 = 1
        else
            ; stop sequencer
            turnoff2 "sequencer13", 0, 0
            ; set sequencer as turned off
            gkSeqOn13 = 0
        endif
    endif
    if changed(gkOn14) == 1 then
        cabbageSet 1, "lblStepLen14", "visible", gkOn14
        if gkIsPlaying == 1 && gkPower == 1 && gkOn14 == 1 && gkSeqOn14 == 0 then
            ; start sequencer
            event "i", "sequencer14", 0, 604800
            ; set sequencer as turned on
            gkSeqOn14 = 1
        else
            ; stop sequencer
            turnoff2 "sequencer14", 0, 0
            ; set sequencer as turned off
            gkSeqOn14 = 0
        endif
    endif
    if changed(gkOn15) == 1 then
        cabbageSet 1, "lblStepLen15", "visible", gkOn15
        if gkIsPlaying == 1 && gkPower == 1 && gkOn15 == 1 && gkSeqOn15 == 0 then
            ; start sequencer
            event "i", "sequencer15", 0, 604800
            ; set sequencer as turned on
            gkSeqOn15 = 1
        else
            ; stop sequencer
            turnoff2 "sequencer15", 0, 0
            ; set sequencer as turned off
            gkSeqOn15 = 0
        endif
    endif
    
    ; update step button visibilities
    if changed(gkStepNum0) == 1 then
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible0 = kX < gkStepNum0 ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq0Step%d", kX), "visible", kStepVisible0
            kX += 1
        od
    endif
    if changed(gkStepNum1) == 1 then
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible1 = kX < gkStepNum1 ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq1Step%d", kX), "visible", kStepVisible1
            kX += 1
        od
    endif
    if changed(gkStepNum2) == 1 then
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible2 = kX < gkStepNum2 ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq2Step%d", kX), "visible", kStepVisible2
            kX += 1
        od
    endif
    if changed(gkStepNum3) == 1 then
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible3 = kX < gkStepNum3 ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq3Step%d", kX), "visible", kStepVisible3
            kX += 1
        od
    endif
    if changed(gkStepNum4) == 1 then
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible4 = kX < gkStepNum4 ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq4Step%d", kX), "visible", kStepVisible4
            kX += 1
        od
    endif
    if changed(gkStepNum5) == 1 then
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible5 = kX < gkStepNum5 ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq5Step%d", kX), "visible", kStepVisible5
            kX += 1
        od
    endif
    if changed(gkStepNum6) == 1 then
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible6 = kX < gkStepNum6 ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq6Step%d", kX), "visible", kStepVisible6
            kX += 1
        od
    endif
    if changed(gkStepNum7) == 1 then
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible7 = kX < gkStepNum7 ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq7Step%d", kX), "visible", kStepVisible7
            kX += 1
        od
    endif
    if changed(gkStepNum8) == 1 then
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible8 = kX < gkStepNum8 ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq8Step%d", kX), "visible", kStepVisible8
            kX += 1
        od
    endif
    if changed(gkStepNum9) == 1 then
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible9 = kX < gkStepNum9 ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq9Step%d", kX), "visible", kStepVisible9
            kX += 1
        od
    endif
    if changed(gkStepNum10) == 1 then
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible10 = kX < gkStepNum10 ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq10Step%d", kX), "visible", kStepVisible10
            kX += 1
        od
    endif
    if changed(gkStepNum11) == 1 then
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible11 = kX < gkStepNum11 ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq11Step%d", kX), "visible", kStepVisible11
            kX += 1
        od
    endif
    if changed(gkStepNum12) == 1 then
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible12 = kX < gkStepNum12 ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq12Step%d", kX), "visible", kStepVisible12
            kX += 1
        od
    endif
    if changed(gkStepNum13) == 1 then
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible13 = kX < gkStepNum13 ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq13Step%d", kX), "visible", kStepVisible13
            kX += 1
        od
    endif
    if changed(gkStepNum14) == 1 then
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible14 = kX < gkStepNum14 ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq14Step%d", kX), "visible", kStepVisible14
            kX += 1
        od
    endif
    if changed(gkStepNum15) == 1 then
        ; refresh visibility for all columns
        kX = 0
        while kX < 16 do
            kStepVisible15 = kX < gkStepNum15 ? 1 : 0
            ; set visibility
            cabbageSet 1, sprintfk("btnSeq15Step%d", kX), "visible", kStepVisible15
            kX += 1
        od
    endif

    ; clear sequence
    if changed(kClear) == 1 || changed(kRandom) == 1 then
        kY = 0
        while kY < 16 do
            kX = 0
            while kX < 16 do
                cabbageSetValue sprintfk("btnSeq%dStep%d", kY, kX), 0, 1
                kX += 1
            od
            kY += 1
        od
    endif

    ; generate random sequences
    if changed(kRandom) == 1 then
        kY = 0
        while kY < 16 do
            kX = 0
            while kX < 16 do
                cabbageSetValue sprintfk("btnSeq%dStep%d", kY, kX), round(rnd:k(1)), 1
                kX += 1
            od
            kY += 1
        od
    endif

    ; trigger sequencers when playback starts
    if changed(gkIsPlaying) == 1 || changed(gkPower) == 1 then
        if gkIsPlaying == 1 && gkPower == 1 then
            ; turn on sequencer for each enabled row
            if gkOn0 == 1 then
                ; start sequencer
                event "i", "sequencer0", 0, 604800
                ; set sequencer as turned on
                gkSeqOn0 = 1
            endif
            if gkOn1 == 1 then
                ; start sequencer
                event "i", "sequencer1", 0, 604800
                ; set sequencer as turned on
                gkSeqOn1 = 1
            endif
            if gkOn2 == 1 then
                ; start sequencer
                event "i", "sequencer2", 0, 604800
                ; set sequencer as turned on
                gkSeqOn2 = 1
            endif
            if gkOn3 == 1 then
                ; start sequencer
                event "i", "sequencer3", 0, 604800
                ; set sequencer as turned on
                gkSeqOn3 = 1
            endif
            if gkOn4 == 1 then
                ; start sequencer
                event "i", "sequencer4", 0, 604800
                ; set sequencer as turned on
                gkSeqOn4 = 1
            endif
            if gkOn5 == 1 then
                ; start sequencer
                event "i", "sequencer5", 0, 604800
                ; set sequencer as turned on
                gkSeqOn5 = 1
            endif
            if gkOn6 == 1 then
                ; start sequencer
                event "i", "sequencer6", 0, 604800
                ; set sequencer as turned on
                gkSeqOn6 = 1
            endif
            if gkOn7 == 1 then
                ; start sequencer
                event "i", "sequencer7", 0, 604800
                ; set sequencer as turned on
                gkSeqOn7 = 1
            endif
            if gkOn8 == 1 then
                ; start sequencer
                event "i", "sequencer8", 0, 604800
                ; set sequencer as turned on
                gkSeqOn8 = 1
            endif
            if gkOn9 == 1 then
                ; start sequencer
                event "i", "sequencer9", 0, 604800
                ; set sequencer as turned on
                gkSeqOn9 = 1
            endif
            if gkOn10 == 1 then
                ; start sequencer
                event "i", "sequencer10", 0, 604800
                ; set sequencer as turned on
                gkSeqOn10 = 1
            endif
            if gkOn11 == 1 then
                ; start sequencer
                event "i", "sequencer11", 0, 604800
                ; set sequencer as turned on
                gkSeqOn11 = 1
            endif
            if gkOn12 == 1 then
                ; start sequencer
                event "i", "sequencer12", 0, 604800
                ; set sequencer as turned on
                gkSeqOn12 = 1
            endif
            if gkOn13 == 1 then
                ; start sequencer
                event "i", "sequencer13", 0, 604800
                ; set sequencer as turned on
                gkSeqOn13 = 1
            endif
            if gkOn14 == 1 then
                ; start sequencer
                event "i", "sequencer14", 0, 604800
                ; set sequencer as turned on
                gkSeqOn14 = 1
            endif
            if gkOn15 == 1 then
                ; start sequencer
                event "i", "sequencer15", 0, 604800
                ; set sequencer as turned on
                gkSeqOn15 = 1
            endif
        
        else
            ; stop sequencers & reset lights
            kY = 0
            while kY < 16 do
                ; stop sequencer
                turnoff2 sprintfk("sequencer%d", kY), 0, 0
                
                ; reset on button lights
                cabbageSet 1, sprintfk("btnOn%d", kY), "outlineThickness", 0
                
                ; reset step button lights
                kX = 0
                while kX < 16 do
                    cabbageSet 1, sprintfk("btnSeq%dStep%d", kY, kX), "outlineThickness", 0
                    kX += 1
                od
                kY += 1
            od
            
            ; reset triggers
            gkTrigger0 = 0
            gkTrigger1 = 0
            gkTrigger2 = 0
            gkTrigger3 = 0
            gkTrigger4 = 0
            gkTrigger5 = 0
            gkTrigger6 = 0
            gkTrigger7 = 0
            gkTrigger8 = 0
            gkTrigger9 = 0
            gkTrigger10 = 0
            gkTrigger11 = 0
            gkTrigger12 = 0
            gkTrigger13 = 0
            gkTrigger14 = 0
            gkTrigger15 = 0
            
            ; reset indexes
            gkStepIndex0 = 0
            gkStepIndex1 = 0
            gkStepIndex2 = 0
            gkStepIndex3 = 0
            gkStepIndex4 = 0
            gkStepIndex5 = 0
            gkStepIndex6 = 0
            gkStepIndex7 = 0
            gkStepIndex8 = 0
            gkStepIndex9 = 0
            gkStepIndex10 = 0
            gkStepIndex11 = 0
            gkStepIndex12 = 0
            gkStepIndex13 = 0
            gkStepIndex14 = 0
            gkStepIndex15 = 0
            
            ; reset last indexes
            gkLastStepIndex0 = -1
            gkLastStepIndex1 = -1
            gkLastStepIndex2 = -1
            gkLastStepIndex3 = -1
            gkLastStepIndex4 = -1
            gkLastStepIndex5 = -1
            gkLastStepIndex6 = -1
            gkLastStepIndex7 = -1
            gkLastStepIndex8 = -1
            gkLastStepIndex9 = -1
            gkLastStepIndex10 = -1
            gkLastStepIndex11 = -1
            gkLastStepIndex12 = -1
            gkLastStepIndex13 = -1
            gkLastStepIndex14 = -1
            gkLastStepIndex15 = -1
            
            ; reset sequencer on values
            gkSeqOn0 = 0
            gkSeqOn1 = 0
            gkSeqOn2 = 0
            gkSeqOn3 = 0
            gkSeqOn4 = 0
            gkSeqOn5 = 0
            gkSeqOn6 = 0
            gkSeqOn7 = 0
            gkSeqOn8 = 0
            gkSeqOn9 = 0
            gkSeqOn10 = 0
            gkSeqOn11 = 0
            gkSeqOn12 = 0
            gkSeqOn13 = 0
            gkSeqOn14 = 0
            gkSeqOn15 = 0
        endif
    endif
endin

instr sequencer0
    if metro(gkMetroSpeed0) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq0Step%d", gkLastStepIndex0), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq0Step%d", gkStepIndex0), "outlineThickness", 4
        
        ; toggle output & on button light
        gkTrigger0 cabbageGetValue sprintfk("btnSeq0Step%d", gkStepIndex0)
        cabbageSet 1, "btnOn0", "outlineThickness", 4 * gkTrigger0

        ; increment step
        gkLastStepIndex0 = gkStepIndex0
        gkStepIndex0 = gkStepIndex0 < gkStepNum0 - 1 ? gkStepIndex0 + 1 : 0
    endif
endin

instr sequencer1
    if metro(gkMetroSpeed1) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq1Step%d", gkLastStepIndex1), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq1Step%d", gkStepIndex1), "outlineThickness", 4
        
        ; toggle output & on button light
        gkTrigger1 cabbageGetValue sprintfk("btnSeq1Step%d", gkStepIndex1)
        cabbageSet 1, "btnOn1", "outlineThickness", 4 * gkTrigger1

        ; increment step
        gkLastStepIndex1 = gkStepIndex1
        gkStepIndex1 = gkStepIndex1 < gkStepNum1 - 1 ? gkStepIndex1 + 1 : 0
    endif
endin

instr sequencer2
    if metro(gkMetroSpeed2) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq2Step%d", gkLastStepIndex2), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq2Step%d", gkStepIndex2), "outlineThickness", 4
        
        ; toggle output & on button light
        gkTrigger2 cabbageGetValue sprintfk("btnSeq2Step%d", gkStepIndex2)
        cabbageSet 1, "btnOn2", "outlineThickness", 4 * gkTrigger2

        ; increment step
        gkLastStepIndex2 = gkStepIndex2
        gkStepIndex2 = gkStepIndex2 < gkStepNum2 - 1 ? gkStepIndex2 + 1 : 0
    endif
endin

instr sequencer3
    if metro(gkMetroSpeed3) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq3Step%d", gkLastStepIndex3), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq3Step%d", gkStepIndex3), "outlineThickness", 4
        
        ; toggle output & on button light
        gkTrigger3 cabbageGetValue sprintfk("btnSeq3Step%d", gkStepIndex3)
        cabbageSet 1, "btnOn3", "outlineThickness", 4 * gkTrigger3

        ; increment step
        gkLastStepIndex3 = gkStepIndex3
        gkStepIndex3 = gkStepIndex3 < gkStepNum3 - 1 ? gkStepIndex3 + 1 : 0
    endif
endin

instr sequencer4
    if metro(gkMetroSpeed4) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq4Step%d", gkLastStepIndex4), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq4Step%d", gkStepIndex4), "outlineThickness", 4
        
        ; toggle output & on button light
        gkTrigger4 cabbageGetValue sprintfk("btnSeq4Step%d", gkStepIndex4)
        cabbageSet 1, "btnOn4", "outlineThickness", 4 * gkTrigger4

        ; increment step
        gkLastStepIndex4 = gkStepIndex4
        gkStepIndex4 = gkStepIndex4 < gkStepNum4 - 1 ? gkStepIndex4 + 1 : 0
    endif
endin

instr sequencer5
    if metro(gkMetroSpeed5) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq5Step%d", gkLastStepIndex5), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq5Step%d", gkStepIndex5), "outlineThickness", 4
        
        ; toggle output & on button light
        gkTrigger5 cabbageGetValue sprintfk("btnSeq5Step%d", gkStepIndex5)
        cabbageSet 1, "btnOn5", "outlineThickness", 4 * gkTrigger5

        ; increment step
        gkLastStepIndex5 = gkStepIndex5
        gkStepIndex5 = gkStepIndex5 < gkStepNum5 - 1 ? gkStepIndex5 + 1 : 0
    endif
endin

instr sequencer6
    if metro(gkMetroSpeed6) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq6Step%d", gkLastStepIndex6), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq6Step%d", gkStepIndex6), "outlineThickness", 4
        
        ; toggle output & on button light
        gkTrigger6 cabbageGetValue sprintfk("btnSeq6Step%d", gkStepIndex6)
        cabbageSet 1, "btnOn6", "outlineThickness", 4 * gkTrigger6

        ; increment step
        gkLastStepIndex6 = gkStepIndex6
        gkStepIndex6 = gkStepIndex6 < gkStepNum6 - 1 ? gkStepIndex6 + 1 : 0
    endif
endin

instr sequencer7
    if metro(gkMetroSpeed7) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq7Step%d", gkLastStepIndex7), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq7Step%d", gkStepIndex7), "outlineThickness", 4
        
        ; toggle output & on button light
        gkTrigger7 cabbageGetValue sprintfk("btnSeq7Step%d", gkStepIndex7)
        cabbageSet 1, "btnOn7", "outlineThickness", 4 * gkTrigger7

        ; increment step
        gkLastStepIndex7 = gkStepIndex7
        gkStepIndex7 = gkStepIndex7 < gkStepNum7 - 1 ? gkStepIndex7 + 1 : 0
    endif
endin

instr sequencer8
    if metro(gkMetroSpeed8) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq8Step%d", gkLastStepIndex8), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq8Step%d", gkStepIndex8), "outlineThickness", 4
        
        ; toggle output & on button light
        gkTrigger8 cabbageGetValue sprintfk("btnSeq8Step%d", gkStepIndex8)
        cabbageSet 1, "btnOn8", "outlineThickness", 4 * gkTrigger8

        ; increment step
        gkLastStepIndex8 = gkStepIndex8
        gkStepIndex8 = gkStepIndex8 < gkStepNum8 - 1 ? gkStepIndex8 + 1 : 0
    endif
endin

instr sequencer9
    if metro(gkMetroSpeed9) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq9Step%d", gkLastStepIndex9), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq9Step%d", gkStepIndex9), "outlineThickness", 4
        
        ; toggle output & on button light
        gkTrigger9 cabbageGetValue sprintfk("btnSeq9Step%d", gkStepIndex9)
        cabbageSet 1, "btnOn9", "outlineThickness", 4 * gkTrigger9

        ; increment step
        gkLastStepIndex9 = gkStepIndex9
        gkStepIndex9 = gkStepIndex9 < gkStepNum9 - 1 ? gkStepIndex9 + 1 : 0
    endif
endin

instr sequencer10
    if metro(gkMetroSpeed10) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq10Step%d", gkLastStepIndex10), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq10Step%d", gkStepIndex10), "outlineThickness", 4
        
        ; toggle output & on button light
        gkTrigger10 cabbageGetValue sprintfk("btnSeq10Step%d", gkStepIndex10)
        cabbageSet 1, "btnOn10", "outlineThickness", 4 * gkTrigger10

        ; increment step
        gkLastStepIndex10 = gkStepIndex10
        gkStepIndex10 = gkStepIndex10 < gkStepNum10 - 1 ? gkStepIndex10 + 1 : 0
    endif
endin

instr sequencer11
    if metro(gkMetroSpeed11) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq11Step%d", gkLastStepIndex11), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq11Step%d", gkStepIndex11), "outlineThickness", 4
        
        ; toggle output & on button light
        gkTrigger11 cabbageGetValue sprintfk("btnSeq11Step%d", gkStepIndex11)
        cabbageSet 1, "btnOn11", "outlineThickness", 4 * gkTrigger11

        ; increment step
        gkLastStepIndex11 = gkStepIndex11
        gkStepIndex11 = gkStepIndex11 < gkStepNum11 - 1 ? gkStepIndex11 + 1 : 0
    endif
endin

instr sequencer12
    if metro(gkMetroSpeed12) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq12Step%d", gkLastStepIndex12), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq12Step%d", gkStepIndex12), "outlineThickness", 4
        
        ; toggle output & on button light
        gkTrigger12 cabbageGetValue sprintfk("btnSeq12Step%d", gkStepIndex12)
        cabbageSet 1, "btnOn12", "outlineThickness", 4 * gkTrigger12

        ; increment step
        gkLastStepIndex12 = gkStepIndex12
        gkStepIndex12 = gkStepIndex12 < gkStepNum12 - 1 ? gkStepIndex12 + 1 : 0
    endif
endin

instr sequencer13
    if metro(gkMetroSpeed13) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq13Step%d", gkLastStepIndex13), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq13Step%d", gkStepIndex13), "outlineThickness", 4
        
        ; toggle output & on button light
        gkTrigger13 cabbageGetValue sprintfk("btnSeq13Step%d", gkStepIndex13)
        cabbageSet 1, "btnOn13", "outlineThickness", 4 * gkTrigger13

        ; increment step
        gkLastStepIndex13 = gkStepIndex13
        gkStepIndex13 = gkStepIndex13 < gkStepNum13 - 1 ? gkStepIndex13 + 1 : 0
    endif
endin

instr sequencer14
    if metro(gkMetroSpeed14) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq14Step%d", gkLastStepIndex14), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq14Step%d", gkStepIndex14), "outlineThickness", 4
        
        ; toggle output & on button light
        gkTrigger14 cabbageGetValue sprintfk("btnSeq14Step%d", gkStepIndex14)
        cabbageSet 1, "btnOn14", "outlineThickness", 4 * gkTrigger14

        ; increment step
        gkLastStepIndex14 = gkStepIndex14
        gkStepIndex14 = gkStepIndex14 < gkStepNum14 - 1 ? gkStepIndex14 + 1 : 0
    endif
endin

instr sequencer15
    if metro(gkMetroSpeed15) == 1 then
        ; switch step lights
        cabbageSet 1, sprintfk("btnSeq15Step%d", gkLastStepIndex15), "outlineThickness", 0
        cabbageSet 1, sprintfk("btnSeq15Step%d", gkStepIndex15), "outlineThickness", 4
        
        ; toggle output & on button light
        gkTrigger15 cabbageGetValue sprintfk("btnSeq15Step%d", gkStepIndex15)
        cabbageSet 1, "btnOn15", "outlineThickness", 4 * gkTrigger15

        ; increment step
        gkLastStepIndex15 = gkStepIndex15
        gkStepIndex15 = gkStepIndex15 < gkStepNum15 - 1 ? gkStepIndex15 + 1 : 0
    endif
endin

instr output    
    ; init channels
    aIns[] init 32
    aOuts[] init 32
    
    ; get inputs
    aIns in
    
    ; set fade time
    kFade = 0.05
    
    ; adjust for gain, trigger, & power for each row in stereo
    aOuts[0] = aIns[0] * gkGain0 * portk(gkTrigger0, kFade) * portk(gkOn0, kFade)
    aOuts[1] = aIns[1] * gkGain0 * portk(gkTrigger0, kFade) * portk(gkOn0, kFade)
    aOuts[2] = aIns[2] * gkGain1 * portk(gkTrigger1, kFade) * portk(gkOn1, kFade)
    aOuts[3] = aIns[3] * gkGain1 * portk(gkTrigger1, kFade) * portk(gkOn1, kFade)
    aOuts[4] = aIns[4] * gkGain2 * portk(gkTrigger2, kFade) * portk(gkOn2, kFade)
    aOuts[5] = aIns[5] * gkGain2 * portk(gkTrigger2, kFade) * portk(gkOn2, kFade)
    aOuts[6] = aIns[6] * gkGain3 * portk(gkTrigger3, kFade) * portk(gkOn3, kFade)
    aOuts[7] = aIns[7] * gkGain3 * portk(gkTrigger3, kFade) * portk(gkOn3, kFade)
    aOuts[8] = aIns[8] * gkGain4 * portk(gkTrigger4, kFade) * portk(gkOn4, kFade)
    aOuts[9] = aIns[9] * gkGain4 * portk(gkTrigger4, kFade) * portk(gkOn4, kFade)
    aOuts[10] = aIns[10] * gkGain5 * portk(gkTrigger5, kFade) * portk(gkOn5, kFade)
    aOuts[11] = aIns[11] * gkGain5 * portk(gkTrigger5, kFade) * portk(gkOn5, kFade)
    aOuts[12] = aIns[12] * gkGain6 * portk(gkTrigger6, kFade) * portk(gkOn6, kFade)
    aOuts[13] = aIns[13] * gkGain6 * portk(gkTrigger6, kFade) * portk(gkOn6, kFade)
    aOuts[14] = aIns[14] * gkGain7 * portk(gkTrigger7, kFade) * portk(gkOn7, kFade)
    aOuts[15] = aIns[15] * gkGain7 * portk(gkTrigger7, kFade) * portk(gkOn7, kFade)
    aOuts[16] = aIns[16] * gkGain8 * portk(gkTrigger8, kFade) * portk(gkOn8, kFade)
    aOuts[17] = aIns[17] * gkGain8 * portk(gkTrigger8, kFade) * portk(gkOn8, kFade)
    aOuts[18] = aIns[18] * gkGain9 * portk(gkTrigger9, kFade) * portk(gkOn9, kFade)
    aOuts[19] = aIns[19] * gkGain9 * portk(gkTrigger9, kFade) * portk(gkOn9, kFade)
    aOuts[20] = aIns[20] * gkGain10 * portk(gkTrigger10, kFade) * portk(gkOn10, kFade)
    aOuts[21] = aIns[21] * gkGain10 * portk(gkTrigger10, kFade) * portk(gkOn10, kFade)
    aOuts[22] = aIns[22] * gkGain11 * portk(gkTrigger11, kFade) * portk(gkOn11, kFade)
    aOuts[23] = aIns[23] * gkGain11 * portk(gkTrigger11, kFade) * portk(gkOn11, kFade)
    aOuts[24] = aIns[24] * gkGain12 * portk(gkTrigger12, kFade) * portk(gkOn12, kFade)
    aOuts[25] = aIns[25] * gkGain12 * portk(gkTrigger12, kFade) * portk(gkOn12, kFade)
    aOuts[26] = aIns[26] * gkGain13 * portk(gkTrigger13, kFade) * portk(gkOn13, kFade)
    aOuts[27] = aIns[27] * gkGain13 * portk(gkTrigger13, kFade) * portk(gkOn13, kFade)
    aOuts[28] = aIns[28] * gkGain14 * portk(gkTrigger14, kFade) * portk(gkOn14, kFade)
    aOuts[29] = aIns[29] * gkGain14 * portk(gkTrigger14, kFade) * portk(gkOn14, kFade)
    aOuts[30] = aIns[30] * gkGain15 * portk(gkTrigger15, kFade) * portk(gkOn15, kFade)
    aOuts[31] = aIns[31] * gkGain15 * portk(gkTrigger15, kFade) * portk(gkOn15, kFade)
    
    ; set outputs
    out aOuts
endin

</CsInstruments>
<CsScore>
f0 z
i "startup" 0 0
i "main" 0 604800
i "output" 0 604800
</CsScore>
</CsoundSynthesizer>